# encoding: ascii
# api: powershell
# title: Add SSL Cert to IIS
# description: How to add a SSL Certificate to IIS with Powershell as well as set the SSL Binding for the site that’s using the certificate.
# version: 0.1
# type: function
# author: Brian H Madsen
# license: CC0
# function: Add-SSLCertificate
# x-poshcode-id: 6634
# x-archived: 2017-03-15T06:38:37
# x-published: 2017-11-25T19:48:00
#
# This uses a PFX certificate file.
#
function Add-SSLCertificate{
    param([string]$pfxPath,[string]$pfxPassword,[string]$hostHeader,[string]$siteName)

    $certMgr = New-Object -ComObject IIS.CertObj -ErrorAction SilentlyContinue    
    $certMgr.ImportToCertStore($pfxPath,$pfxPassword,$true,$true)

    Import-Module WebAdministration;
    New-WebBinding -Name $siteName -Port 443 -Protocol https -HostHeader $hostHeader    
}
