﻿# encoding: utf-8
# api: powershell
# title: Add-on.PShellExec.psm1
# description: This file was uploaded by a PowerGUI Script Editor Add-on.
# version: 2.3.0.1503
# type: module
# author: Les Papier                                                                                        
# license: CC0
# x-poshcode-id: 4269
# x-archived: 2013-06-29T07:03:55
# x-published: 2013-06-26T15:07:00
#
#
#######################################################################################################################
# File:             Add-on.PShellExec.psm1                                                                            #
# Author:           Les Papier                                                                                        #
# Publisher:        infoSpectrum Inc.                                                                                 #
# Copyright:        Â© 2011 infoSpectrum. All rights reserved.                                                         #
# Usage:            To load this module in your Script Editor:                                                        #
#                   1. Open the Script Editor.                                                                        #
#                   2. Select "PowerShell Libraries" from the File menu.                                              #
#                   3. Check the Add-on.PShellExec module.                                                            #
#                   4. Click on OK to close the "PowerShell Libraries" dialog. 	                                      #
#                   5. Download the latest PShellExec version from http://www.screencast.com/t/fsawR7vSur9s           #
#					6. Unzip the download in the same directory where this Add-on.PShellExec.psm1 file is located     #
#######################################################################################################################

Set-StrictMode -Version 2

#region Initialize the Script Editor Add-on.

if ($Host.Name â��ne 'PowerGUIScriptEditorHost') { return }
if ($Host.Version -lt '2.3.0.1503') {
	[System.Windows.Forms.MessageBox]::Show("The ""$(Split-Path -Path $PSScriptRoot -Leaf)"" Add-on module requires version 2.3.0.1503 or later of the Script Editor. The current Script Editor version is $($Host.Version).$([System.Environment]::NewLine * 2)Please upgrade to version 2.3.0.1503 and try again.","Version 2.3.0.1503 or later is required",[System.Windows.Forms.MessageBoxButtons]::OK,[System.Windows.Forms.MessageBoxIcon]::Information) | Out-Null
	return
}

$pgse = [Quest.PowerGUI.SDK.ScriptEditorFactory]::CurrentInstance

#endregion

#region Load resources from disk.

$iconLibrary = @{	
	PShellExecIcon16 = New-Object System.Drawing.Icon -ArgumentList "$PSScriptRoot\Resources\secure.ico",16,16
	# TODO: Load icons into this table.
	#           PShellExecIcon32 = New-Object System.Drawing.Icon -ArgumentList "$PSScriptRoot\Resources\PShellExec.ico",32,32
}

$imageLibrary = @{
	
	PShellExecImage16 = $iconLibrary['PShellExecIcon16'].ToBitmap()
	# TODO: Load images into this table.
	#           PShellExecImage32 = $iconLibrary['PShellExecIcon32'].ToBitmap()
}

#endregion


#region Create the command.
#Write-Host 'Ctrl+Alt+S: Secure Scripts'
if (-not ($PShellCmd = $pgse.Commands['ToolsCommand.PShellExec'])) 
{
	$PShellCmd = New-Object -TypeName Quest.PowerGUI.SDK.ItemCommand -ArgumentList 'ToolsCommand','PShellExec'
	$PShellCmd.Text = '&Secure Scripts'
	$PShellCmd.Image = $imageLibrary['PShellExecImage16']
	$PShellCmd.AddShortcut('Ctrl+Alt+S')
	$psarg = 'PShellExec.ps1.bin'
	if ([Quest.PowerGUI.SDK.ScriptEditorFactory]::CurrentInstance.CurrentDocumentWindow.Document.Path) 
	{
		$psarg =  '/a:"'+[Quest.PowerGUI.SDK.ScriptEditorFactory]::CurrentInstance.CurrentDocumentWindow.Document.Path +'"'
	}	
	$PShellCmd.ScriptBlock = 
	{
			$runDir = Split-Path -Path $MyInvocation.MyCommand.Definition -Parent
			$aFile = (Join-Path $rundir 'PShellExec.ps1.bin')			
			start-process  $runDir\PShellExec.exe -ArgumentList $aFile,$psarg 
	}
	$pgse.Commands.Add($PShellCmd)
}

#endregion

#region Create the menu item in the Tools menu.
if (($toolMenu = $pgse.Menus['MenuBar.Tools']) -and
	(-not ($PShellItem = $toolMenu.Items['ToolsCommand.PShellExec']))) 
{ 
	$toolMenu.Items.Add($PShellCmd)
	if ($PShellItem = $toolMenu.Items['ToolsCommand.PShellExec']) 
		{ $PShellItem.FirstInGroup = $true }
}
#endregion

#region Clean-up the Add-on when it is removed.

$ExecutionContext.SessionState.Module.OnRemove = 
{
	# Remove command and menu items
	$pgse = [Quest.PowerGUI.SDK.ScriptEditorFactory]::CurrentInstance
	if (($PShellCmd = $pgse.Commands['ToolsCommand.PShellExec'])) 
		{ $pgse.Commands.Add($PShellCmd) }
	if (($toolMenu = $pgse.Menus['MenuBar.Tools']) -and
		(($PShellItem = $toolMenu.Items['ToolsCommand.PShellExec']))) 
		{ $toolMenu.Items.Remove($PShellItem) }
}

#endregion
