# encoding: ascii
# api: powershell
# title: Demo-ShouldProcess
# description: Shows how to use SupportsShouldProcess and Confirm
# version: 0.1
# type: function
# author: Joel Bennett
# license: CC0
# function: Test-Confirm
# x-poshcode-id: 6401
# x-archived: 2016-06-25T05:29:55
# x-published: 2016-06-20T19:54:00
#
#
function Test-Confirm {
    [CmdletBinding(SupportsShouldProcess=$true, ConfirmImpact="Medium")]
    param([Switch]$Force)

    $RejectAll = $false;
    $ConfirmAll = $false;
    Write-Verbose "ConfirmPreference is $ConfirmPreference"

    foreach($file in ls) {
        if($PSCmdlet.ShouldProcess( "Removed the file '$($file.Name)'",
                                    "Remove the file '$($file.Name)'?",
                                    "Removing Files" )) {
            if($Force -Or $PSCmdlet.ShouldContinue("Are you REALLY sure you want to remove '$($file.Name)'?", "Removing '$($file.Name)'", [ref]$ConfirmAll, [ref]$RejectAll)) {
                "Removing $File"
            }
        }
    }
}
