# encoding: ascii
# api: powershell
# title: Format-HPCCOutput
# description: This takes the output from HP Configuration Collector for an EVA and converts it to useful CSVs for reporting.
# version: 0.1
# type: script
# author: jgrote
# license: CC0
# x-poshcode-id: 5908
# x-archived: 2015-07-02T03:26:10
# x-published: 2015-06-24T23:20:00
#
#

#This script uses the HP Configuration Collector Output and produces meaningful Poweshell Objects and CSVs out of them for capacity planning.

$hpccfile = "C:\users\jgrote\desktop\SWMALEVA01.xml"

$xmlRAW = [xml](get-content $hpccfile)

$xmlEVA = $xmlRAW.scanmastercollection.collectiondata.eva

$evaDiskGroup = $xmlEVA.diskgroup.object

$evaDisks = $xmlEVA.disk.object

$evaVirtualDisks = $xmleva.virtualdisk.object

$evaDiskGroup | export-csv -notypeinformation "$($xmlEVA.devicename)-diskgroups.csv" 
$evaDisks | export-csv -notypeinformation "$($xmlEVA.devicename)-disks.csv" 
$evaVirtualDisks | export-csv -notypeinformation "$($xmlEVA.devicename)-virtualdisks.csv"
