# encoding: ascii
# api: powershell
# title: Get-User
# description: This function is an attempt to duplicate the Quest Get-QADUser cmdlet without using any third party snap-ins. If you want to run it against a Global Catalog you simply need to replace LDAP: with GC: and you will want to comment out the lines that pull the password last set and last logon timestamp unless you happen to be replicating those to your GC.
# version: 0.1
# type: function
# author: Jonathan Walz
# license: CC0
# function: Get-User
# x-poshcode-id: 735
# x-archived: 2009-04-29T17:57:59
#
#
function Get-User($user)
{
	# this function should be passed the CN of the user to be returned
	$dom = [System.DirectoryServices.ActiveDirectory.Domain]::GetCurrentDomain() 
	$root = [ADSI] "LDAP://$($dom.Name)"
	$searcher = New-Object System.DirectoryServices.DirectorySearcher $root
	$searcher.filter = "(&(objectCategory=person)(objectClass=user)(cn=$user))"
	$user = $searcher.FindOne()
	[System.Collections.Arraylist]$names = $user.Properties.PropertyNames
	[System.Collections.Arraylist]$props = $user.Properties.Values
	$userobj = New-Object System.Object
	for ($i = 0; $i -lt $names.Count)
		{
			$userobj | Add-Member -type NoteProperty -Name $($names[$i]) -Value $($props[$i])
			$i++
		}
	$userobj.pwdlastset = [System.DateTime]::FromFileTime($userobj.pwdlastset)
	$userobj.lastlogontimestamp = [System.DateTime]::FromFileTime($userobj.lastlogontimestamp)
	return $userobj
}
