# encoding: ascii
# api: powershell
# title: QAD.psm1
# description: This is the file you need to load Quest’s Active Directory snap-in as a module.  Just put this in a folder with all the dlls …
# version: 1.0
# type: module
# author: Joel Bennett
# license: CC0
# x-poshcode-id: 2692
# x-archived: 2011-05-27T22:44:10
# x-published: 2011-05-24T20:03:00
#
# I’m posting it as an example of what my Reflection module’s New-ModuleManifestFromSnapin function can do.
#
#
# Module manifest for module 'QAD'
#
# Generated from: Quest.ActiveRoles.ADManagement
#
# Generated on: 1/28/2011
#

@{

# Script module or binary module file associated with this manifest
ModuleToProcess = 'Quest.ActiveRoles.ArsPowerShellSnapIn.dll'

# Version number of this module.
ModuleVersion = '1.0'

# ID used to uniquely identify this module
GUID = '2b34f8ae-e6eb-4d14-9536-6e69cf4f31ed'

# Author of this module
Author = 'Quest.ActiveRoles.ADManagement'

# Company or vendor of this module
CompanyName = 'Quest Software, Inc.'

# Copyright statement for this module
Copyright = 'Quest Software, Inc.'

# Description of the functionality provided by this module
Description = 'This Windows PowerShell snap-in contains cmdlets to manage Active Directory and Quest ActiveRoles Server.'

# Minimum version of the Windows PowerShell engine required by this module
PowerShellVersion = ''

# Name of the Windows PowerShell host required by this module
PowerShellHostName = ''

# Minimum version of the Windows PowerShell host required by this module
PowerShellHostVersion = ''

# Minimum version of the .NET Framework required by this module
DotNetFrameworkVersion = ''

# Minimum version of the common language runtime (CLR) required by this module
CLRVersion = ''

# Processor architecture (None, X86, Amd64, IA64) required by this module
ProcessorArchitecture = ''

# Modules that must be imported into the global environment prior to importing this module
RequiredModules = @()

# Assemblies that must be loaded prior to importing this module
RequiredAssemblies = 'Quest.ActiveRoles.ArsPowerShellSnapIn.DirectoryAccess.dll', 
               'Microsoft.Practices.Unity.Interception.dll', 
               'Quest.ActiveRolesServer.Common.dll', 
               'Quest.ActiveRolesServer.Common.Services.dll', 
               'Microsoft.Practices.Unity.dll', 'NLog.dll', 
               'Quest.ActiveRoles.ArsPowerShellSnapIn.Utility.dll', 
               'Interop.ActiveDs.dll', 
               'Microsoft.Practices.Unity.StaticFactory.dll', 
               'Interop.ArsAdsi.dll'

# Script files (.ps1) that are run in the caller's environment prior to importing this module
ScriptsToProcess = @()

# Type files (.ps1xml) to be loaded when importing this module
TypesToProcess = 'Quest.ActiveRoles.ADManagement.Types.ps1xml'

# Format files (.ps1xml) to be loaded when importing this module
FormatsToProcess = 'Quest.ActiveRoles.ADManagement.Format.ps1xml'

# Modules to import as nested modules of the module specified in ModuleToProcess
NestedModules = @()

# Functions to export from this module
FunctionsToExport = '*'

# Cmdlets to export from this module
CmdletsToExport = '*'

# Variables to export from this module
VariablesToExport = '*'

# Aliases to export from this module
AliasesToExport = '*'

# List of all modules packaged with this module
ModuleList = @()

# List of all files packaged with this module
FileList = @()

# Private data to pass to the module specified in ModuleToProcess
PrivateData = ''

}
